
//解析Cookie
function parseCookie(cookie) {
	cookie = cookie.replace(/\s/g, "").split(";");
	let ret = {};
	cookie.forEach(v => {
		v = v.split("=");
		let name = decodeURIComponent(v.shift());
		ret[name] = decodeURIComponent(v.join("="));
	})
	return ret;
}

export default function createCookie(cookie = "") {
	let newCookie = [];
	let oldCookie = parseCookie(cookie);
	return {
		get cookie() {
			return oldCookie;
		},
		get(name) {
			return name in oldCookie ? oldCookie[name] : "";
		},
		set(name, value, {expire, domain, path, secure, httpOnly} = {}) {
				newCookie.push({name , value, expire, domain, path, secure, httpOnly});

		},
		clear(name, {domain, path, secure, httpOnly} = {}) {
			let expire = "Fri, 31 Dec 1999 16:00:00 GMT";
			if (name) {
				newCookie.push({name , value: "delete", expire , domain, path, secure, httpOnly});
			} else {
				newCookie = [];
				for (let name in oldCookie) {
					newCookie.push({name , value: "delete", expire, domain, path, secure, httpOnly});
				}
			}
		},
		header() {
			return newCookie.map(({name, value, expire, domain, path, secure, httpOnly}) => {
				if (!name) {
					return "";
				}
				let cookie = [encodeURI(name) + "=" + encodeURI(value)];
				if (expire) {
					cookie.push("Expires=" + expire);
				}
				if (domain) {
					cookie.push("Domain=" + encodeURI(domain));
				}
				if (path) {
					cookie.push("Path=" + encodeURI(path));
				}
				if (secure) {
					cookie.push("Secure");
				}
				if (httpOnly) {
					cookie.push("HttpOnly");
				}
				return cookie.join("; ")
			}).filter(x=>x);
		},
	}
}
